import { HttpErrorResponse, HttpResponse } from '@angular/common/http';
import { Observable } from 'rxjs';
export interface RequestState<T> {
    readonly isLoading: boolean;
    readonly noData: boolean;
    readonly isLoaded: boolean;
    readonly isLoadedWithData: boolean;
    readonly isLoadedWithoutData: boolean;
    readonly value?: T;
    readonly error?: HttpErrorResponse | Error | unknown;
}
export interface LoadingState<T> extends RequestState<T> {
    readonly isLoading: true;
    readonly error: undefined;
}
export interface LoadedState<T> extends RequestState<T> {
    readonly isLoading: false;
    readonly error: undefined;
}
export interface ErrorState<T> extends RequestState<T> {
    readonly isLoading: false;
}
export declare const loadingState: <T>(value?: T | undefined) => LoadingState<T>;
export declare const loadedState: <T>(value?: T | undefined) => LoadedState<T>;
export declare const errorState: <T>(error: HttpErrorResponse | Error | unknown, value?: T | undefined) => ErrorState<T>;
export declare function requestStates<T>(): (source: Observable<HttpResponse<T> | T>) => Observable<RequestState<T>>;
